<?php
/*
Plugin Name: 123 IIS Permalink
Plugin URI: http://putzlowitsch.de/123-iis-permalink
Description: Ermöglicht die Verwendung von schönen Permalinks ohne /index.php/... beim IIS . Ein benutzerdefiniertes Fehlerdokument wird "mißbraucht".
Author: Ingo Henze
Version: 0.11
Author URI: http://putzlowitsch.de/
*/ 

// Falls nicht vorhanden, plw123_debugfile_write Dummy definieren
if ( !function_exists('plw123_debugfile_write') ) :
	function plw123_debugfile_write( $message ) {
}
endif;

function plw123nrp_iis_index301redirect() {
	list( $redirect_status, $redirect_url ) = explode( ';', $_SERVER['QUERY_STRING'] );
	
	// Regulärer Aufruf
	if( $redirect_status == '' ) {
		$redirect_url= $_SERVER['REQUEST_URI'];
		plw123_debugfile_write( "URI: $redirect_url" );
		if( preg_match( '#^/index\.php(.+)#i', $redirect_url, $matches ) ) {
			plw123_debugfile_write( "Redirect: {$matches[1]}" );

			@header( "{$_SERVER['SERVER_PROTOCOL']} 301 Moved Permanently" );
			@header( "Location: {$matches[1]}" );
			exit;
		}
	}

}

// Für den IIS den Redirect-String zerlegen
// Beispiel: 404;http://example.com/eine-seite 
function plw123nrp_iis_redirect() {
	list( $redirect_status, $redirect_url ) = explode( ';', $_SERVER['QUERY_STRING'] );

	plw123_debugfile_write( "Status: $redirect_status" );
	plw123_debugfile_write( "URL: $redirect_url" );

	if( $redirect_status == '404' || ($redirect_status == '405' && $_SERVER['REQUEST_METHOD'] == 'POST' ) ) {
			
		$parsed = parse_url( $redirect_url );
		
		$redirect_uri = '';
		$redirect_uri .= isset( $parsed['path'] ) ? $parsed['path'] : '';
		$redirect_uri .= isset( $parsed['query'] ) ? '?'.$parsed['query'] : '';
		$redirect_uri .= isset( $parsed['fragment'] ) ? '#'.$parsed['fragment'] : '';

		plw123_debugfile_write( "URI: $redirect_uri" );
		
		$_SERVER['REDIRECT_STATUS'] = $redirect_status;
		$_SERVER['REQUEST_URI'] = $redirect_uri;
		
		// $_GET korrigieren
		if( isset( $parsed['query'] ) )
		  parse_str( $parsed['query'], $_GET );
		
		// Fehler 405 Method Not Allowed, wenn kein 'POST'
		if( $redirect_status == '405' && $_SERVER['REQUEST_METHOD'] != 'POST' ) {
			$text = 'Method not allowed';
			//@header( "Status: $redirect_status $text" );
			@header( "HTTP/1.1 $redirect_status $text" );
			@header( "Allow: GET, HEAD, POST" );
			die( "<html><head><title>$text</title></head><body><h1>{$_SERVER['SERVER_PROTOCOL']} $redirect_status $text</h1></body></html>" );
		}
	}
}

plw123nrp_iis_index301redirect();

plw123nrp_iis_redirect();

?>